'
' ####################
' #####  PROLOG  #####
' ####################
'
' Test gnu_regex library.
'
VERSION "0.0001"
CONSOLE
'
	IMPORT  "xst"				' Standard library : required by most programs
	IMPORT  "gnu_regex"
	IMPORT  "xsx"				' Extended standard library
'	IMPORT  "xio"				' Console input/ouput library
'	IMPORT  "user32"		' user32.dll
'	IMPORT  "kernel32"	' kernel32.dll
'	IMPORT  "shell32"		' shell32.dll
'	IMPORT  "msvcrt"		' msvcrt.dll

'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION ReFindAll (string$, pattern$, match$[])

$$LINE$ = "---------------------------------------------"
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	REGEX_T r
	REGMATCH_T m

' validate character is numeric
	s$ = "1234567890abc"
	pat$ = "[0-9]"
	ReFindAll (@s$, @pat$, @match$[])
	upp = UBOUND(match$[])
	FOR i = 0 TO upp
		PRINT match$[i]
	NEXT i

	PRINT $$LINE$

	s$ = "1abcd 2abcd 3abcd 4abcd"
	pat$ = "[0-9]abcd"
	ReFindAll (@s$, @pat$, @match$[])
	upp = UBOUND(match$[])
	FOR i = 0 TO upp
		PRINT match$[i]
	NEXT i

	PRINT $$LINE$

	' search for email addresses
	pat$ = "([A-Za-z0-9\+\_]+)@([A-Za-z0-9_]+)\.([A-Za-z]{2,4})([,.]?)"
	s$ = s$ + "blah obiewankanobee@starsys.com\n"
	s$ = s$ + "blah blah blah\n"
	s$ = s$ + "obiewankanobee@starsys.com\n"
	s$ = s$ + "blah blah blah\n"
	s$ = s$ + "blah yoda@outthere.net\n"
	s$ = s$ + "mailto:darthv@deathstar.tw\n"
	ret = ReFindAll (@s$, @pat$, @match$[])
	PRINT "ReFindAll ret="; ret
	upp = UBOUND(match$[])
	FOR i = 0 TO upp
		PRINT match$[i]
	NEXT i

	PRINT $$LINE$

	s$ = "(compatible)"
	pat$ = "\\(.*l"
	ret = ReFindAll (@s$, @pat$, @match$[])
	PRINT "ReFindAll ret="; ret
	upp = UBOUND(match$[])
	FOR i = 0 TO upp
		PRINT match$[i]
	NEXT i

	PRINT $$LINE$

	s$ = "<td style=\"vertical-align: top; background-color: rgb(255, 255, 255);\"> _
			 <a href=\"http://xblite.org/doc/public/htmlcontrol.zip\">htmlcontrol.zip</a> _
			 - This library is an html rendering control and can be used like any _
			 standard windows control. It is free for non-commercial purposes. With _
			 a little effort, a fairly good web-browser could be created with this control.</td>"

' get all <a > tags
	pat$ = "<a[^>]*>"
	ret = ReFindAll (@s$, @pat$, @match$[])
	PRINT "ReFindAll ret="; ret
	upp = UBOUND(match$[])
	FOR i = 0 TO upp
		PRINT match$[i]
	NEXT i

	PRINT $$LINE$

	' get all urls
	pat$ = "(http|https)://([a-zA-Z0-9\\~\\!\\@\\#\\$\\%\\^\\&amp;\\*\\(\\)\\_\\=\\+\\\\\\/\\?\\.\\:\\;\\'\\,\\-]*)?"
	ret = ReFindAll (@s$, @pat$, @match$[])
	PRINT "ReFindAll ret="; ret
	upp = UBOUND(match$[])
	FOR i = 0 TO upp
		PRINT match$[i]
	NEXT i

	PRINT $$LINE$

' get all html enclosed tags <>
	pat$ = "<[^>]*>"
	ret = ReFindAll (@s$, @pat$, @match$[])
	PRINT "ReFindAll ret="; ret
	upp = UBOUND(match$[])
	FOR i = 0 TO upp
		PRINT match$[i]
	NEXT i

	PRINT $$LINE$

	' get date (does not check for valid dates)
	s$ = "Today's date is 10-31-2016, but independence day is 7/4/2016."
	pat$ = "[0-3]?[0-9].[0-3]?[0-9].([0-9]{2})?[0-9]{2}"
	ret = ReFindAll (@s$, @pat$, @match$[])
	PRINT "ReFindAll ret="; ret
	upp = UBOUND(match$[])
	FOR i = 0 TO upp
		PRINT match$[i]
	NEXT i

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
'
' #######################
' #####  ReFindAll  #####
' #######################
'
' Find all instances of RE pattern in string.
'
FUNCTION ReFindAll (string$, pattern$, match$[])

	REGEX_T re
	REGMATCH_T m

	IFZ string$ THEN RETURN
	IFZ pattern$ THEN RETURN
	DIM match$[64]

	error = regcomp (&re, &pattern$, $$REG_EXTENDED)
	IF error THEN
		regfree (&re)
		errbuf$ = NULL$(128)
		regerror (error, &re, &errbuf$, LEN(errbuf$))
		PRINT "regcomp error: "; error; " : "; CSIZE$(errbuf$)
		RETURN
	END IF

	sAddr = &string$
	bAddr = sAddr
	error = regexec (&re, sAddr, 1, &m, 0) ' find first match

	IF error THEN
		errbuf$ = NULL$(128)
		regerror (error, &re, &errbuf$, LEN(errbuf$))
		PRINT "regexec error: "; error; " : "; CSIZE$(errbuf$)
		DIM match$[]
		regfree (&re)
		RETURN
	END IF

	offset = sAddr - bAddr
	match$[index] = MID$(string$, offset+m.rm_so+1, m.rm_eo-m.rm_so)
	sAddr = sAddr + m.rm_eo

	INC index

	DO WHILE (error == 0) 					' while matches found
		' substring found between pm.rm_so and pm.rm_eo
    ' this call to regexec() finds the next match
    error =  regexec (&re, sAddr, 1, &m, $$REG_NOTBOL)
		IFZ error THEN
			IF index = UBOUND(match$[]) THEN REDIM match$[index<<1]
			offset = sAddr - bAddr
			match$[index] = MID$(string$, offset+m.rm_so+1, m.rm_eo-m.rm_so)
			sAddr = sAddr + m.rm_eo
			INC index
		END IF
  LOOP

	regfree (&re)
	REDIM match$[index-1]
	RETURN ($$TRUE)

END FUNCTION
END PROGRAM